/*
 * errors.h
 *
 *  Created on: 6 déc. 2023
 *      Author: fanch
 */

#ifndef ERRORS_H_
#define ERRORS_H_

#include <string>
class Error {
public:
	Error() { }
	Error(const std::string& msg) : m_msg(msg) { }
	Error(const char* msg) : m_msg(msg) { }
	Error(const Error& err) : m_msg(err.m_msg) {}
	Error& operator=(const Error& err){
		m_msg = err.m_msg;
		return *this;
	}

	const std::string& to_string() const {return m_msg; }

protected:
	std::string m_msg;

};


class FileNotFoundError : public Error {
public:
	FileNotFoundError() : Error() {}
	FileNotFoundError(const char* s) : Error(s) {}
	FileNotFoundError(const std::string& s) : Error(s) {}
};

class IOError : public Error {
public:
	IOError() : Error() {}
	IOError(const char* s) : Error(s) {}
	IOError(const std::string& s) : Error(s) {}
};

class MemoryError : public Error {
public:
	MemoryError() : Error() {}
	MemoryError(const char* s) : Error(s) {}
	MemoryError(const std::string& s) : Error(s) {}
};



#endif /* ERRORS_H_ */
