/*
 * FileSoundInput.cpp
 *
 *  Created on: 20 déc. 2023
 *      Author: fanch
 */

#include "FileSoundInput.h"

FileSoundInput::FileSoundInput(const std::string &path, unsigned int sc) {
	m_path = path;
	m_type = Type::FILE;
	SF_INFO info;
	m_fd = sf_open(m_path.c_str(), SFM_READ, &info);
	if (!m_fd){
		throw "Erreur de lecture de fichier";
	}
	m_channles = info.channels;
	m_sample_rate = info.samplerate;
	m_sample_size = info.format;
	init(sc);
}

FileSoundInput::~FileSoundInput() {
	close();
}

LADSPA_Data* FileSoundInput::_next(LADSPA_Data* x) {
	sf_count_t len;
	len = sf_readf_float(m_fd, x, (sf_count_t)m_sample_count);
	if(!len) return NULL;
	return x;
}

void FileSoundInput::close() {
	if(m_fd){
		sf_close(m_fd);
	}
}
