/*
 * SoundInput.h
 *
 *  Created on: 20 déc. 2023
 *      Author: fanch
 */

#ifndef SRC_IO_SOUNDINPUT_H_
#define SRC_IO_SOUNDINPUT_H_

#include <ladspa.h>
#include <cstdlib>

class SoundInputStream {
public:
	~SoundInputStream(){}

	enum Type {
		REALTIME,
		FILE
	};

	bool is_realtime() const { return m_type == Type::REALTIME; }
	bool is_file() const { return m_type == Type::FILE; }

	LADSPA_Data* next(LADSPA_Data* input= NULL){
		if(!input){
			input = m_buffer;
		}
		return _next(input);

	}


protected:
	void init(unsigned long sc) {
		m_sample_count = sc;
		m_buffer = new LADSPA_Data[sc];
	}

	virtual LADSPA_Data* _next(LADSPA_Data*) = 0;
	Type m_type;
	unsigned long m_sample_rate;
	unsigned int m_channles;
	unsigned int m_sample_size;
	unsigned int m_sample_count;
	LADSPA_Data* m_buffer;

};



#endif /* SRC_IO_SOUNDINPUT_H_ */
