/*
 * SDLWindow.cpp
 *
 *  Created on: 17 déc. 2023
 *      Author: fanch
 */

#include "SDLWindow.h"

SDLWindow::SDLWindow(int w, int h){
	m_w = w;
	m_h = h;
	m_window =  SDL_CreateWindow("Ma première application SDL2",SDL_WINDOWPOS_UNDEFINED,
			SDL_WINDOWPOS_UNDEFINED,
			w,
			h,
			SDL_WINDOW_SHOWN);
	m_renderer = SDL_CreateRenderer(m_window, -1, 0);

	m_texture = SDL_CreateTexture(m_renderer,
		SDL_PIXELFORMAT_ARGB8888, SDL_TEXTUREACCESS_STATIC, w, h);
	m_pixels = new Uint32[w*h];
}
SDLWindow::~SDLWindow(){
	delete[] m_pixels;
	SDL_DestroyTexture(m_texture);
	SDL_DestroyRenderer(m_renderer);
}

void SDLWindow::init(){
	SDL_Init(SDL_INIT_VIDEO);
}

void SDLWindow::update(){
	SDL_UpdateTexture(m_texture, NULL, m_pixels, m_w* sizeof(Uint32));
	SDL_RenderClear(m_renderer);
	SDL_RenderCopy(m_renderer, m_texture, NULL, NULL);
	SDL_RenderPresent(m_renderer);
}


void SDLWindow::set_value(float* value, int size, float ratio){

	for(int i=0; i<m_h; i++){
		for(int j=0; j<m_w; j++){
			m_pixels[j+m_w*i] = 0;
		}
	}
	for(int j=0; j<m_w; j+=2){
		int h = ((value[j]*ratio) + m_h/2);
		m_pixels[h*m_w+j] = 0xFFFFFF00;
		m_pixels[h*m_w+j+1] = 0xFFFFFF00;
	}
	update();
}
